---
title: What is Pomerium?
lang: en-US
sidebarDepth: 0
meta:
  - name: keywords
    content: >-
      pomerium, overview, identity access proxy, beyondcorp, zero trust,
      reverse proxy, ztn, zero trust networks
---

# What is Pomerium

## Overview?

Pomerium is an identity-aware proxy that enables secure access to internal applications. Pomerium provides a standardized interface to add access control to applications regardless of whether the application itself has authorization or authentication baked-in. Pomerium gateways both internal and external requests, and can be used in situations where you'd typically reach for a VPN.

<center>
<iframe width="800" height="450" src="https://www.youtube.com/embed/WGwC9ULDnAY?rel=0" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
</center>

Pomerium can be used to:

- provide a **single-sign-on gateway** to internal applications.
- enforce **dynamic access policy** based on **context**, **identity**, and **device identity**.
- aggregate access logs and telemetry data.
- perform delegated user authorization for service-based authorization systems:
  - [Istio](/guides/istio.md)
  - [Google Cloud](/guides/cloud-run.md)
- add unified access and identity to [custom, on-prem, and hosted apps and services](https://www.pomerium.com/integrations/)
- serve as a **VPN alternative**.

